Public Class CustomTreeNode
    Inherits TreeNode
    Private _Control As Control

    Public Property Control() As Control
        Get
            Return _Control
        End Get
        Set(ByVal Value As Control)
            _Control = Value
            If Not Me.TreeView Is Nothing Then
                Me.TreeView.Controls.Add(_Control)
                If _Control.Height > Me.TreeView.ItemHeight Then Me.TreeView.ItemHeight = _Control.Height + 1
            End If
            Dim item As CustomTreeNode
            For Each item In Me.TreeView.Nodes
                item.Refresh()
            Next
        End Set
    End Property


    Public Sub Refresh()
        If Not Me.TreeView Is Nothing Then
            _Control.Top = CInt((Me.TreeView.ItemHeight - _Control.Height) / 2 + Me.Bounds.Top)
            _Control.Left = Me.Bounds.Left + Me.Bounds.Width + 10
            If Me.IsVisible Then
                _Control.Visible = True
            Else
                _Control.Visible = False
            End If
            Dim item As CustomTreeNode
            For Each item In Me.Nodes
                item.Refresh()
            Next
        End If
    End Sub

End Class